--[[
	Author: Darcey.Lloyd@gmail.com

	USEFUL TO GET FRAME NAME IN GAME CHAT:
	/run print(GetMouseFocus():GetName() .. "\n")
--]]


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DCoordsUpdateFrame = CreateFrame("frame","DCoordsUpdateFrame");
--DCoordsUpdateFrame:RegisterEvent("ADDON_LOADED");
DCoordsUpdateFrame:RegisterEvent("VARIABLES_LOADED");
DCoordsUpdateFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
DCoordsUpdateFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
DCoordsUpdateFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
DCoordsUpdateFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
DCoordsUpdateFrame:RegisterEvent("ZONE_CHANGED_INDOORS");
DCoordsUpdateFrame:RegisterEvent("ZONE_CHANGED");
--DCoordsUpdateFrame:RegisterEvent("PLAYER_LOGOUT");

-- MAIN UPDATE
DCoordsUpdateFrame:SetScript("OnUpdate", function(self) DCoordsUpdateHandler2() end);



DCoordsUpdateFrame:SetScript("OnEvent", function(self,event,addonName)
	-- log(event);
	if (event == "ADDON_LOADED") then
		-- never gets called ?? (dont use)
		-- if (addonName == "DCoords") then
			log("DCoords v"..DCoordsVersion.." ADDON_LOADED!");
			DCoordsGVar["DCZone"] = GetZoneText();
			DCoordsGVar["DCSubZone"] = GetSubZoneText();
			
		-- end
	elseif (event == "VARIABLES_LOADED") then
		log("DCoords v"..DCoordsVersion.." VARIABLES_LOADED!");
		DCoordsGVar["DCVarsLoaded"] = true;
		DCoordsGVar["DCZone"] = GetZoneText();
		DCoordsGVar["DCSubZone"] = GetSubZoneText();
		DCoordsInit();
		--DCoordsUpdateFrame:SetScript("OnEvent",nil);
	elseif (event == "ZONE_CHANGED") then
		--toChat("DCoords: Event [" .. event .. "]");
		DCoordsGVar["DCZone"] = GetZoneText();
		DCoordsGVar["DCSubZone"] = GetSubZoneText();
		minimapSetFont();
	elseif (event == "ZONE_CHANGED_NEW") then
		--toChat("DCoords: Event [" .. event .. "]");
		DCoordsGVar["DCZone"] = GetZoneText();
		DCoordsGVar["DCSubZone"] = GetSubZoneText();
		minimapSetFont();
	elseif (event == "ZONE_CHANGED_NEW_AREA") then
		--toChat("DCoords: Event [" .. event .. "]");
		DCoordsGVar["DCZone"] = GetZoneText();
		DCoordsGVar["DCSubZone"] = GetSubZoneText();
		minimapSetFont();
	elseif (event == "ZONE_CHANGED_INDOORS") then
		--toChat("DCoords: Event [" .. event .. "]");
		DCoordsGVar["DCZone"] = GetZoneText();
		DCoordsGVar["DCSubZone"] = GetSubZoneText();
		minimapSetFont();
	elseif (event == "PLAYER_ENTERING_WORLD") then
		--toChat("DCoords: Event [" .. event .. "]");
	elseif (event == "PLAYER_REGEN_DISABLED") then
		--toChat("DCoords: Event [" .. event .. "]");
		DCoordsInCombat = true;
	elseif (event == "PLAYER_REGEN_ENABLED") then
		--toChat("DCoords: Event [" .. event .. "]");
		DCoordsInCombat = false;
	else
		
		--log("DCoords: WARNING: Unhandled event: [" .. event .. "]");
	end
end);
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function showOptions()
	playClick();
	InterfaceOptionsFrame_OpenToCategory(DCoordsGVar["DCOptions"].Main.name); -- will open interface menu
	InterfaceOptionsFrame_OpenToCategory(DCoordsGVar["DCOptions"].Other.name); -- will  expand of sub options of DCoords
	InterfaceOptionsFrame_OpenToCategory(DCoordsGVar["DCOptions"].Main.name); -- will select main DCoords entry
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #






-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function DCoordsSlashCommandHandler(cmd)
	log("DCoordsSlashCommandHandler(): " .. cmd);
	
	if (cmd == nil or cmd == "" or string.find(cmd, "help") ~= nil) then
		print(" ");
		print("DCoords v" .. DCoordsVersion .. " slash commands:");
		print("  /DC menu - show menu");
		print("  /DC show  - show coordinates");
		print("  /DC hide - hide coordinates");
		print("  /DC reset - reset position and settings");
		return;
	end
	
	strSearchResult = string.find(cmd,"reset");
	if (strSearchResult ~= nil) then
		print("DCoords attempting to reset positions...");
		reset();
		return;
	end
	
	if (cmd == "menu") then
		showOptions();
		return;
	end
	
	if (cmd == "show menu") then
		showOptions();
		return;
	end
		
	if (cmd == "show") then
		DCoordsDBZ["MainBar"].visible = true;
		mainBarSetVisibility();
		return;
	end
	
	if (cmd == "hide") then
		DCoordsDBZ["MainBar"].visible = false;
		mainBarSetVisibility();
		return;
	end


	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #







-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function DCoordsInit()
	log("DCoordsInit()");
	
	--DCoordsSetVars();
		
	-- Remove the cancel button
	InterfaceOptionsFrameCancel:Hide()
	InterfaceOptionsFrameOkay:SetAllPoints(InterfaceOptionsFrameCancel)

	-- Make clicking cancel the same as clicking okay
	InterfaceOptionsFrameCancel:SetScript("OnClick", function()
		InterfaceOptionsFrameOkay:Click()
	end)	
	
	-- Ensure vars are ok
	--DCoordsDBZ = nil;

	-- One time calls
	--SetMapToCurrentZone(); -- Broken in v8.x
	
	-- Init
	initOptions();
	--initWorldMapCoordinates(); -- broken in v8.x
	initObjectiveTracker();
	initMainBar();
	initMinimapCoordinates();
	

		
	mainBarSetVisibility();
	mainBarSetBackground();
	mainBarSetFont();
	mainBarSetPosition();

	
	
	-- Setup slash commands
	SlashCmdList["DCoordsCOMMAND"] = DCoordsSlashCommandHandler;
	SLASH_DCoordsCOMMAND1 = "/dc";
	
	-- Message
	toChat(" ");
	toChat("DCoords v"..DCoordsVersion);
	toChat("DCoords: To view DCoords settings right click coordinates bar");
	toChat("DCoords: To drag DCoords hold SHIFT + LEFT CLICK then DRAG.");
	toChat("DCoords: To reset DCoords type /DC reset.");
	
	-- Get scale
	DCUIScale = DCoordsGVar["DCMainBar"]:GetEffectiveScale();
	-- log("DCUIScale = " .. DCUIScale);

	-- DCoords is ready
	DCoordsGVar["DCReady"] = true;
	DCoordsGVar["DCLoaded"] = true;
	

	-- local a = DCoordsUIP:GetChildren();
	-- print(a);

	wait(4,delayedCalls);
	
	
	
	-- EXTRAS
	
	
	--showOptions();

	
	--[[
	local a = MinimapZoneTextButton:GetChildren();
	local b = MinimapCluster:GetChildren();
	
	
	
	
	for k,v in pairs(b) do
		--print(v:GetName());
	end
	
	
	--local kids = { Minimap:GetChildren() };
	local kids = { MinimapCluster:GetChildren() };
	
	local function myTest(frame)
		frame:Hide();
		return frame:GetName();
	end
	
	for key,child in ipairs(kids) do
		local retOK, ret1 = pcall(myTest,child);
		print(ret1);
		
	end
	--]]
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
local setupFrameDragAndPos = function()

	for i =1, #DCoordsDBZ["Frames"] do
		if (DCoordsDBZ["Frames"][i] ~= nil) then
			print(i)
			print(DCoordsDBZ["Frames"][i][1]) -- frame
			print(DCoordsDBZ["Frames"][i][2]) -- frameX
			print(DCoordsDBZ["Frames"][i][3]) -- frameY
			print("---");

			if (DCoordsDBZ["Frames"][i][1] ~= nil) then
				local targetFrame = DCoordsDBZ["Frames"][i][1]
				local targetFrameX = DCoordsDBZ["Frames"][i][2]
				local targetFrameY = DCoordsDBZ["Frames"][i][3]

				targetFrame:SetScale(2);

				if (DCoordsDBZ["FrameEnableDrag"] == true) then
					-- targetFrame:SetClampedToScreen(false)
					-- targetFrame:EnableMouse(true);
					-- targetFrame:SetMovable(true);
					-- targetFrame:SetResizable(true);

					targetFrame:HookScript("OnClick", function(self, button)
						print(self:GetName() .. " clicked with " .. button)
					   end)
					  

	
					targetFrame:SetScript("OnMouseDown", function(self, button)
						if button == "LeftButton" and not self.isMoving then
						 self:StartMoving();
						 self.isMoving = true;
						end
					end)
					  targetFrame:SetScript("OnMouseUp", function(self, button)
						if button == "LeftButton" and self.isMoving then
						 self:StopMovingOrSizing();
						 self.isMoving = false;
						end
					  end)
				end

			end
		end
	end
end



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
local popup;

local showChangesPopup = function()
	-- DCoordsDebug= true;
	if (DCoordsDebug) then
		DCoordsDBZ["OneTimePopup"] = nil;
	end

	if (DCoordsDBZ["OneTimePopup"] == nil) then
		DCoordsDBZ["OneTimePopup"] = DCoordsVersion;
		-- print("DCoords: Show changes popup! (1)");
	else
		if (DCoordsDBZ["OneTimePopup"] ~= DCoordsVersion) then
			-- print("DCoords: Show changes popup! (2)");
			DCoordsDBZ["OneTimePopup"] = DCoordsVersion;
		else
			-- print("DCoords: Do not show changes popup!");
			return false;
		end
	end

	-- print("showChangesPopup()");
	-- local f = CreateFrame("Frame",nil,UIParent)
	popup = CreateFrame("frame","DCoordsPopup",UIParent);
    popup:SetFrameStrata("HIGH");
    popup:EnableMouse(false);
	-- popup:SetResizable(true);
	-- popup:SetMovable(true);
	local popupW = 330; 
	local popupH = 380;
    popup:SetWidth(popupW);
    popup:SetHeight(popupH);
    
    popup:ClearAllPoints(true);
    popup:SetPoint("CENTER",15,20);
    popup:ClearAllPoints(true);
	popup:SetPoint("CENTER",0,0);
	
	

	SetDCoordsFrameBG(popup,1);

	-- local t = popup:CreateTexture(nil,"BACKGROUND")
	-- popup:SetBackdrop({
	-- 	bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", 
	-- 	edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
	-- 	tile=1, tileSize=32, edgeSize=32, 
	-- 	insets={left=11, right=12, top=12, bottom=11}
	-- })
	-- t:SetAllPoints(popup)
	-- popup.texture = t

	-- local texture:SetTexture(r, g, b[, a]);
	-- popup.texture = popup:CreateTexture()
	-- popup.texture:SetColorTexture(0, 0, 0, 1);
	-- popup.texture:SetAllPoints(popup)

	local maxLabelWidth = 0;
	local setMaxLabelWidth = function(w)
		if (w>maxLabelWidth) then
			maxLabelWidth = w;
		end
	end

	-- Set some text
	msg = "";
	msg = msg .. "DCoords v" .. tostring(DCoordsVersion) .. " - What's new" .. "\n\n";
	local txt1 = createLabel("DCoordsPopupText1",popup,msg,20,1,1,1,1,"LEFT",20,-10);
	
	msg = "";
	msg = msg .. "Want a WoW Classic version of this addon?\n";
	local txt2 = createLabel("DCoordsPopupText2",popup,msg,18,1,0.7,0,1,"LEFT",20,-50);

	msg = "";
	msg = msg .. "  Leave a message on the curse forum requesting it.\n";
	msg = msg .. "\n\n";
	local txt3 = createLabel("DCoordsPopupText3",popup,msg,16,1,1,1,1,"LEFT",20,-75);
	setMaxLabelWidth(txt3:GetWidth());


	msg = "";
	msg = msg .. "8.2 Bug fix (Taint)\n";
	local txt4 = createLabel("DCoordsPopupText4",popup,msg,18,1,0.7,0,1,"LEFT",20,-130);

	msg = "";
	msg = msg .. "  A taint was being caused by some of the non coordinate features,\n";
	msg = msg .. "  these have now been removed to prevent the taint.\n";
	msg = msg .. "\n\n";
	local txt5 = createLabel("DCoordsPopupText5",popup,msg,16,1,1,1,1,"LEFT",20,-160);
	setMaxLabelWidth(txt5:GetWidth());



	msg = "";
	msg = msg .. "Removed some features\n";
	local txt6 = createLabel("DCoordsPopupText6",popup,msg,18,1,0.7,0,1,"LEFT",20,-235);

	msg = "";
	msg = msg .. "  Removed center windows and select window drag.\n  Use dragemall addon instead.\n";
	msg = msg .. "\n\n";
	local txt7 = createLabel("DCoordsPopupText7",popup,msg,16,1,1,1,1,"LEFT",20,-260);
	setMaxLabelWidth(txt7:GetWidth());



	-- Width adjust
	-- print("maxLabelWidth = " .. tostring(maxLabelWidth));
	popupW = maxLabelWidth + 50;
	popup:SetWidth(popupW);


	-- btnReset
	local function btnCloseClickHandler()
		popup:Hide();
		popup = nil;
	end
	local btnCloseX = popupW/2 - 50;
	local btnCloseY = -(popupH - 40);
	local btnClose = createButton("ClosePopupButton",popup,"CLOSE",100,btnCloseX,btnCloseY,btnCloseClickHandler);


	

	-- popup:SetPoint("CENTER",0,0)
	popup:Show()


end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #







-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- Some things just dont work unless we delay! or need a delay
function delayedCalls()
	-- log("delayedCalls()");
	initMinimapCoordinates();
	mainBarSetPosition();
	showChangesPopup();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
















local waitTable = {};
local waitFrame = nil;

function wait(delay, func, ...)
  if(type(delay)~="number" or type(func)~="function") then
    return false;
  end
  if(waitFrame == nil) then
    waitFrame = CreateFrame("Frame","WaitFrame", UIParent);
    waitFrame:SetScript("onUpdate",function (self,elapse)
      local count = #waitTable;
      local i = 1;
      while(i<=count) do
        local waitRecord = tremove(waitTable,i);
        local d = tremove(waitRecord,1);
        local f = tremove(waitRecord,1);
        local p = tremove(waitRecord,1);
        if(d>elapse) then
          tinsert(waitTable,i,{d-elapse,f,p});
          i = i + 1;
        else
          count = count - 1;
          f(unpack(p));
        end
      end
    end);
  end
  tinsert(waitTable,{delay,func,{...}});
  return true;
end






function logTable(tbl)
	for k, v in pairs( tbl ) do
		--print(v);
		print( type(v) .. ": " .. tostring(v));
		if (type(v) == "table") then
			logTable(v)
		end
	end
end

function logTable2(tbl)
	for k, v in pairs( tbl ) do
		if (type(v) == "table") then
			print(v);
		else
			print(v)
		end
	end
end




--[[
-- EXPERIEMENTAL REFERENCES
local oo = _G["MinimapZoneTextButton"];
oo:Hide();	
	
	
--]]




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function reset()
	log("reset()");
	initVars();
	--PlaySound("QUESTADDED");
	--PlaySound(8959,"MASTER"); --7.3
    ReloadUI();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
