--[[
	Author: Darcey.Lloyd@gmail.com
--]]


-- Var ini
local position;

local t = 0;
local tLim = 0;
local px = 0;
local py = 0;
local zone = "";
local subZone = "";
local zoneText = "";
local inInstance = false;
local instanceType = "";
local runOnceDone = false;

local mapCoordinatesFrameCreated = false;
local mapLabel;

local DCoordsFrameVarsSet = false;
local t2 = 0; -- timing for window drag and center
local dragAndCenterTimeLimit = 15; -- 30 is noticable but quick

if (not CoordinatesDB) then
	CoordinatesDB = {}
	CoordinatesDB["worldmap"] = true
	CoordinatesDB["minimap"] = true
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DCoordsUpdateHandler2 = function()

	-- DCoords ready?
	if ( DCoordsGVar["DCReady"] == false ) then
		return;
	end
	
	-- instance flags
	inInstance, instanceType = IsInInstance();
	
	-- Handle update timing
	t = t+1;
	-- MinimapZoneText:SetText(t);

	if (inInstance == true) then
		-- Raid/Dungeon update frequency
		tLim = DCoordsDBZ["updateDelayInDungeonOrRaid"];
	elseif (DCoordsInCombat == true) then
		-- Combat update frequency
		tLim = DCoordsDBZ["updateDelayInCombat"];
	else
		-- Normal update frequency
		tLim = DCoordsDBZ["updateDelay"];
	end
	
	if (t <= tLim) then
		return;
	else
		t = 0;
	end


	-- Will show what frame the mouse is over	
	-- if (GetMouseFocus():GetName()) then
	-- 	print( GetMouseFocus():GetName() );
	-- end


	-- Set coordinates
	SetCoordinates();
	SetMiniMapCoordinates();
	SetWorldMapCoordinates();
	SetMainBarCoordinates();

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function SetMainBarCoordinates()



	-- Prevent update if MainBar is not visible
	if ( DCoordsGVar["DCMainBar"]:IsVisible() == false) then
		return;
	end

	if (DCoordsDBZ["MainBar"].showZone == true) then
		zone = DCoordsGVar["DCZone"];
	else
		zone = "";
	end

	if (DCoordsDBZ["MainBar"].showSubZone == true) then
		subZone = DCoordsGVar["DCSubZone"];
	else
		subZone = "";
	end



	local mainBarCoordinates = DCoordsRoundTo(px,DCoordsDBZ["MainBar"].decimalPrecision) .. " : " .. DCoordsRoundTo(py,DCoordsDBZ["MainBar"].decimalPrecision);



	if (tonumber(px) < 0.01 and tonumber(py) < 0.01) then
		if (zone ~= "") and (subZone ~= "") then
			location = zone .. " - " .. subZone;
		elseif (zone == "") and (subZone ~= "") then
			location = subZone;
		elseif (zone ~= "") and (subZone == "") then
			location = zone;
		else
			location = DCoordsTempText;
		end
	else
		if (zone == "") and (subZone == "") then
			location = mainBarCoordinates;
		elseif (zone ~= "") and (subZone == "") then
			location = zone .. " - " .. mainBarCoordinates;
		elseif (zone == "") and (subZone ~= "") then
			location = subZone .. " - " .. mainBarCoordinates;
		elseif (zone ~= "") and (subZone ~= "") then
			if (zone == subZone) then
				location = zone .. " - " .. mainBarCoordinates;
			else
				location = zone .. " - " .. subZone .. " - " .. mainBarCoordinates;
			end
		else
			location = "      ";
		end
	end

	location = "  " .. location .. "  ";

	--DCoordsGVar["DCMainBarText"]:SetText(" " .. t .. " " .. location);
	DCoordsGVar["DCMainBarText"]:SetText(location);
	--DCoordsGVar["DCMainBarText"]:SetJustifyH("LEFT");


	if (DCoordsGVar["DCMainBar"]:IsVisible() == true) then
		
		local frameW = DCoordsGVar["DCMainBarText"]:GetStringWidth() + DCoordsDBZ["MainBar"].paddingLeftRight;
		local frameH = DCoordsGVar["DCMainBarText"]:GetStringHeight() + DCoordsDBZ["MainBar"].paddingTopBottom;
		
		if (oldW ~= frameW) then
			oldW = frameW;
			DCoordsGVar["DCMainBar"]:SetWidth(frameW);
			DCoordsGVar["DCMainBar"]:SetHeight(frameH);
			local dcW = tostring(DCoordsRoundTo(frameW,2));
			local dcH = tostring(DCoordsRoundTo(frameH,2));
			--toChat("FRAME UPDATE:" .. dcW .. ":" .. dcH);
		end
	end		




end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function SetWorldMapCoordinates()

	-- Update WorldMap
	--if ( DCoordsDBZ["WorldMap"].visible == true and WorldMapFrame:IsVisible() == true ) then
	if (CoordinatesDB["worldmap"] and WorldMapFrame:IsVisible()) then

		if ( DCoordsInCombat == false ) then

			-- Get the cursor's coordinates
			local cursorX, cursorY = GetCursorPosition()
	
			-- Calculate cursor position
			local scale = WorldMapFrame:GetCanvas():GetEffectiveScale()
			cursorX = cursorX / scale
			cursorY = cursorY / scale
			local width = WorldMapFrame:GetCanvas():GetWidth()
			local height = WorldMapFrame:GetCanvas():GetHeight()
			local left = WorldMapFrame:GetCanvas():GetLeft()
			local top = WorldMapFrame:GetCanvas():GetTop()
			cursorX = (cursorX - left) / width * 100
			cursorY = (top - cursorY) / height * 100
			mapLocationString = "Cursor: "..format("%.2f , %.2f    ", cursorX, cursorY)
			-- Player position
			if (not mapID) then
				mapID = C_Map.GetBestMapForUnit("player")
			end
			if (mapID) then
				position = C_Map.GetPlayerMapPosition(mapID,"player")
			end
			if (position and position.x ~= 0 and position.y ~= 0 ) then
				px = format("%.2f", position.x * 100)
				py = format("%.2f",position.y * 100)
				mapLocationString = " Player: "..px.." , "..py .. "    " .. mapLocationString
			else
				mapLocationString = " Player: 0,0    " .. mapLocationString
			end
			-- Add text to world map
			-- WorldMapFrame.BorderFrame.TitleText:SetText(mapLocationString)
			
		
		
			-- Works but is a hacky way to attach the text!
			if (not mapCoordinatesFrameCreated) then
				mapCoordinatesFrameCreated = true;
				local attachTo = WorldMapFrameHomeButton;
				local msg = "";
				mapLabel = createLabel("DCoordsWorldmapLabel",attachTo,msg,12,1,1,1,1,"LEFT",200,-490);
			else
				mapLabel:SetText(mapLocationString)
			end




		end
		
	end

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #






-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function SetMiniMapCoordinates()

	if (MinimapZoneText:IsVisible() == true) then
		
		if (MinimapZoneText ~= nil) then
	
			if ( DCoordsDBZ["MinimapLocationBar"].coordinatesEnabled == true) then
				local miniMapCoordinates = DCoordsRoundTo(px,DCoordsDBZ["MinimapLocationBar"].decimalPrecision) .. " : " .. DCoordsRoundTo(py,DCoordsDBZ["MinimapLocationBar"].decimalPrecision);
				if (DCoordsDBZ["MinimapLocationBar"].displayZone == true) then
					if (coordsWereNull == true) then
						MinimapZoneText:SetText( DCoordsGVar["DCZone"] );
					else
						MinimapZoneText:SetText( DCoordsGVar["DCZone"] .. " - " .. miniMapCoordinates );
					end
				else
					if (coordsWereNull == true) then
						MinimapZoneText:SetText( DCoordsGVar["DCZone"] );
					else
						MinimapZoneText:SetText( miniMapCoordinates );
					end
				end	
			end

		end	

	end

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #







local mapIDSet = false;
local coordsWereNull = false;
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function SetCoordinates()

	px = 0;
	py = 0;
	
	-- Get the players coordinates
	if (CoordinatesDB["minimap"] and Minimap:IsVisible()) then
		if (not mapIDSet) then
			mapID = C_Map.GetBestMapForUnit("player")
		end
		if (mapID) then
			local position = C_Map.GetPlayerMapPosition(mapID,"player") -- Memory leak on this (nothing I can do about it)
			if (position) then
				px = position.x;
				py = position.y;
			end
			position = nil;
		end
	end

	-- print(px .. " - " .. py);

	--px, py = GetPlayerMapPosition("player");
	
	-- Check for nils
	px = px or 0;
	py = py or 0;
	
	px = px * 100;
	py = py * 100;

	-- Dont do here as each can be set different in options
	-- px = DCoordsRoundTo(px,DCoordsDBZ["MinimapLocationBar"].decimalPrecision);
	-- py = DCoordsRoundTo(py,DCoordsDBZ["MinimapLocationBar"].decimalPrecision);

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

