--[[
	Author: Darcey.Lloyd@gmail.com
--]]


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupPageObjectivesTracker()
	DCoordsGVar["DCOptions"].Objectives = CreateFrame("FRAME", "DCoordsOptionsMainBar");
	local frame = DCoordsGVar["DCOptions"].Objectives; 
	frame.name = "Objectives tracker";
	frame.parent = DCoordsGVar["DCOptions"].Main.name;
	InterfaceOptions_AddCategory(frame);
	
	-- Add background to options to enhance readability
	frame:SetBackdrop({
		bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10,
		insets = { left = 3, right = 3, top = 3, bottom = 3 }
	})
	
	-- Titles
	AddDCoordsOptionsTitles(frame,"Objectives tracker");
	
	
	
	-- Vars
	local px = 10;
	local py = -60;
	local inc = 25;
	local dropDownWidth = 250;
	local sliderWidth = 250;
	local msg = "";
	
	
	
	
	--DCoordsDBZ["Objectives"].enabled
	createCheckbox("cbObjectivesEnabled",frame,"Enable Objectives Tracker featuers",DCoordsDBZ["Objectives"].enabled,px,py,cbDragObjectivesChangeHandler);
	py = py - 20;
	
	
	
	--createLabel((name,frameContainer,text,size,r,g,b,a,justify,x,y)
	msg = "";
	msg = msg .. "Disabling Objectives features will cause a UI RELOAD" .. "";
	local mainInfo1 = createLabel("mainInfo1",frame,msg,15,1,0.5,0.5,1,"LEFT",px,py);
	py = py - 30;
	
	
	
	--DCoordsDBZ["Objectives"].alpha
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function objectivesAlphaChangeHandler(v)
		sliderObjectivesAlphaChangeHandler(v);
	end
	createSlider("objectivesAlphaChangeHandler",frame,0,1,0.1,"Objectives Alpha",DCoordsDBZ["Objectives"].alpha,sliderWidth,1,px,py,objectivesAlphaChangeHandler,true)
	py = py - 40;
	
	
	--DCoordsDBZ["Objectives"].scale
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function objectivesScaleChangeHandler(v)
		sliderObjectivesScaleChangeHandler(v);
	end
	createSlider("objectivesScaleChangeHandler",frame,0.1,1,0.01,"Objectives Scale",DCoordsDBZ["Objectives"].scale,sliderWidth,2,px,py,objectivesScaleChangeHandler,true)
	py = py - 40;
	
	
	
	--DCoordsDBZ["Objectives"].height
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function objectivesHeightChangeHandler(v)
		sliderObjectivesHeightChangeHandler(v);
	end
	createSlider("objectivesHeightChangeHandler",frame,100,900,0.1,"Objectives Height",DCoordsDBZ["Objectives"].height,sliderWidth,1,px,py,objectivesHeightChangeHandler,true)
	py = py - 60;
	
	
	
	
	
	--createLabel((name,frameContainer,text,size,r,g,b,a,justify,x,y)
	local objInfo1Message = "";
	objInfo1Message = objInfo1Message .. "USAGE GUIDE" .. "\n";
	objInfo1Message = objInfo1Message .. "This is how I do it, may not be how you like it or want to use it but this works for me:" .. "\n\n";
	objInfo1Message = objInfo1Message .. "- Enable objectives tracker features (this will enable drag)." .. "\n\n";
	objInfo1Message = objInfo1Message .. "- Set the scale and alpha to how you want it (the values I use are set as default)." .. "\n\n";
	objInfo1Message = objInfo1Message .. "- Change height so that it's as small as you can get it without hiding it." .. "\n\n";
	objInfo1Message = objInfo1Message .. "- Hold SHIFT and LEFT CLICK on title bar, then mouse drag to a position aligning" .. "\n\n";
	 objInfo1Message = objInfo1Message .. "from the base of the objectives tracker." .. "\n\n";
	objInfo1Message = objInfo1Message .. "Bottom aligned is important as it will grow upward when you increase the height." .. "\n\n";
	objInfo1Message = objInfo1Message .. "- Increase the height till you get it to how you want it." .. "\n\n";
	objInfo1Message = objInfo1Message .. "- Done." .. "\n";
	local objInfo1 = createLabel("objInfo1",frame,objInfo1Message,14,1,1,1,1,"LEFT",px,py);
	py = py - 25;
	
	
	
	
	
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
