--[[
	Author: Darcey.Lloyd@gmail.com
--]]


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupPageOther()
	DCoordsGVar["DCOptions"].Other = CreateFrame("FRAME", "DCoordsOptionsMainBar");
	local frame = DCoordsGVar["DCOptions"].Other; 
	frame.name = "Other";
	frame.parent = DCoordsGVar["DCOptions"].Main.name;
	InterfaceOptions_AddCategory(frame);
	
	-- Add background to options to enhance readability
	frame:SetBackdrop({
		bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10,
		insets = { left = 3, right = 3, top = 3, bottom = 3 }
	})
	
	-- Titles
	AddDCoordsOptionsTitles(frame,"Other");
	
	-- Page of settings
	local px = 10;
	local py = -60;
	local inc = 25;
	local dropDownWidth = 200;
	local sliderWidth = 200;
	local msg = "";
	
	
	-- ensure vars are  set
	if (not DCoordsDBZ["updateDelay"]) then
		DCoordsDBZ["updateDelay"] = 5;
	end
	if (not DCoordsDBZ["updateDelayInCombat"]) then
		DCoordsDBZ["updateDelayInCombat"] = 20;
	end
	if (not DCoordsDBZ["updateDelayInDungeonOrRaid"]) then
		DCoordsDBZ["updateDelayInDungeonOrRaid"] = 100;
	end
	
	
	local function sliderUpdateDelay1ChangeHandler(v)
		DCoordsDBZ["updateDelay"] = v;
	end
	createSlider("sliderUpdateDelay",frame,4,100,1,"Coordinates update delay",DCoordsDBZ["updateDelay"],400,0,px,py,sliderUpdateDelay1ChangeHandler,true)
	py = py - 42;
	
	msg = "";
	msg = msg .. "RECOMMENDED SETTINGS:\nFast computers 20 or less, Slow computers 50+" .. "\n\n";
	createLabel("DCUpdateSpeedInfo1",frame,msg,14,1,0.5,0.5,1,"LEFT",27,py);
	py = py - 60;
	
	
	
	
	local function sliderUpdateDelay2ChangeHandler(v)
		DCoordsGVar["updateDelayInCombat"] = v;
	end
	createSlider("sliderUpdateDelayInCombat",frame,10,200,1,"Coordinates update delay in combat",DCoordsDBZ["updateDelayInCombat"],400,0,px,py,sliderUpdateDelay2ChangeHandler,true)
	py = py - 42;
	
	msg = "";
	msg = msg .. "RECOMMENDED SETTINGS:\nFast computers 20 or less, Slow computers 50+" .. "\n\n";
	createLabel("DCUpdateSpeedInfo1",frame,msg,14,1,0.5,0.5,1,"LEFT",27,py);
	py = py - 60;
	
	
	
	local function sliderUpdateDelay3ChangeHandler(v)
		DCoordsGVar["updateDelayInDungeonOrRaid"] = v;
	end
	createSlider("sliderUpdateDelayInDungeonOrRaid",frame,10,200,1,"Coordinates update delay in dungeon or raid",DCoordsDBZ["updateDelayInDungeonOrRaid"],400,0,px,py,sliderUpdateDelay3ChangeHandler, true)
	py = py - 42;
	
	msg = "";
	msg = msg .. "RECOMMENDED SETTINGS:\nFast computers 20 or less, Slow computers 50+" .. "\n\n";
	createLabel("DCUpdateSpeedInfo1",frame,msg,14,1,0.5,0.5,1,"LEFT",27,py);
	py = py - 60;
	
	
	
	
	
	--[[
	
	--createDropDown(name,frameContainer,width,labels,default,x,y,clickHandlerFunction)
	local labels = {
		"Option 1",
		"Option 2",
		"Option 3",
		"Option 4",
	};
    
    local function dp1ChangeHandler(selectedIndex)
	    print("------------------------");
	    print("selectedIndex = " .. selectedIndex);
    end
    
	local default = 1;
	local dp1 = createDropDown("DropDownTest1",frame,200,labels,1,px,py,dp1ChangeHandler);
	py = py - inc;
	local dp2 = createDropDown("DropDownTest2",frame,200,labels,0,px,py,dp1ChangeHandler);
	dp2:SetSelected(1);
	
	--]]
	


	

	
	-- btnReset
	local function btnResetClickHandler()
		log("btnResetClickHandler()");
		reset();
	end
	local btnReset = createButton("ResetButton",frame,"RESET DCOORDS",150,px,-530,btnResetClickHandler);
	


		
	
	-- btn??
	local function btnWTFClickHandler()
		PlaySoundFile("Sound\\Music\\CityMusic\\Stormwind\\stormwind_intro-moment.mp3");
	end
	local btnWTF = createButton("btnWTF",frame,"??",50,px+560,-542,btnWTFClickHandler);
	
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #






-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function xbtnResetClickHandler()
	log("btnResetClickHandler()");

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
